My3DArray load_csv(String fileName) {
  Table table = loadTable(fileName, "header");
  My3DArray list = new My3DArray(n, n, 3);
  println(table.getRowCount() + " total rows in table"); 

  for (int i = 0; i < table.getRowCount(); i++) {
    TableRow row = table.getRow(i);
    float x = row.getFloat("x");
    float y = row.getFloat("y");
    float z = row.getFloat("z");
    float year = row.getFloat("year");
    list.setElementIn3DArray(x, i%n, i/n);
    list.setElementIn3DArray(y, i%n, i/n);
    list.setElementIn3DArray(z, i%n, i/n);
    list.setElementIn3DArray(year, i%n, i/n);
  }
  
  return list;
}


float[][] my3DarrayTo2Darray(My3DArray array3d, int index)
{
  int dim = array3d.get1stDimensionSize();
  float[][] result = new float[dim][dim];
  // Initialize 2D array values
  for (int i = 0; i < dim; i++) {
    for (int j = 0; j < dim; j++) {
      result[i][j] = (float) array3d.getElementIn3DArray(i, j, index);
    }
  }
  return result;
}


My3DArray array2DToMy3Darray(float[][] array2d)
{
  int dim = array2d[0].length;
  My3DArray result = new My3DArray(dim, dim, 3);
  // Initialize 2D array values
  for (int i = 0; i < dim; i++) {
    for (int j = 0; j < dim; j++) {
      // print( array3d.getElementIn3DArray(i, j, Z) + " ");
      float x = i * 1.0/(dim - 1);
      float y = j * 1.0/(dim - 1);
      float z = array2d[i][j];
      result.setElementIn3DArray(x, i, j);
      result.setElementIn3DArray(y, i, j);
      result.setElementIn3DArray(z, i, j);
    }
  }
  return result;
}