float[][] midpointDisplace(float[][] base, float roughness) {
  int baseSize = base[0].length;

  int newSize = (2 * baseSize) - 1;
  
  float[][] newArray = new float[newSize][newSize];
  
  // Resize
  for (int i = 0; i < newSize; i += 2) {
    for (int j = (!(i % 2 == 0)) ? 1 : 0; j < newSize; j += 2) {
      newArray[i][j] = base[i / 2][j / 2];
    }
  }
  
  // Diamond algorithm
  for (int i = 1; i < newSize; i += 2) {
    for (int j = 1; j < newSize; j += 2) {

      float a = newArray[i - 1][j - 1];
      float b = newArray[i - 1][j + 1];
      float c = newArray[i + 1][j - 1];
      float d = newArray[i + 1][j + 1];
      newArray[i][j] = (a + b + c + d) / 4;

      float r = random(-roughness, roughness);
      /*
      if (newArray[i][j] + r > 255 )
        newArray[i][j] = 255;
      else if(newArray[i][j] + r < 0)
        newArray[i][j] = 0;
      else
      */
      newArray[i][j] += r;
    }
  }
  
  // Square algorithm
  for (int i = 0; i < newSize; ++i) {
    for (int j = (i % 2 == 0) ? 1: 0; j < newSize; j += 2) {
      // get surrounding values
      float a = 0, b = a, c = a, d = a;
      if (i != 0) a = newArray[i - 1][j];
      if (j != 0) b = newArray[i][j - 1];
      if (j + 1 != newSize) c = newArray[i][j + 1];
      if (i + 1 != newSize) d = newArray[i + 1][j];

      // average calculation
      if (i == 0) newArray[i][j] = (b + c + d) / 3;
      else if (j == 0) newArray[i][j] = (a + c + d) / 3;
      else if (j + 1 == newSize) newArray[i][j] = (a + b + d) / 3;
      else if (i + 1 == newSize) newArray[i][j] = (a + b + c) / 3;
      else newArray[i][j] = (a + b + c + d) / 4;

      float r = random(-roughness, roughness);
      /*
      if (newArray[i][j] + r > 255 )
        newArray[i][j] = 255;
      else if(newArray[i][j] + r < 0)
        newArray[i][j] = 0;
      else
      */
      newArray[i][j] += r;
    }
  }
  
  return newArray;  // Returns an array of 3 ints: 20, 40, 60 
}